-- Schema updates for EduPlanYearly model --

-- v1 (0.9) --

ALTER TABLE PL_HOLIDAY
  ADD COLUMN `HOLIDAY_NAME` VARCHAR(28) NOT NULL DEFAULT '?' AFTER `H_ID`;

update PL_HOLIDAY H, RujelStatic.PL_HOLIDAY_TYPE T
set H.HOLIDAY_NAME = T.HOLIDAY_NAME
where H.HD_TYPE = T.HT_ID;

ALTER TABLE PL_HOLIDAY
 MODIFY COLUMN `HOLIDAY_NAME` VARCHAR(28) NOT NULL,
 DROP COLUMN `HD_TYPE`;

INSERT INTO PL_HOLIDAY  (H_ID, HOLIDAY_NAME, DATE_BEGIN, DATE_END)
  SELECT HT_ID, HOLIDAY_NAME, MAKEDATE(2010,BEGIN_DAY) + INTERVAL BEGIN_MONTH MONTH AS DATE_BEGIN,
    MAKEDATE(2010,END_DAY) + INTERVAL END_MONTH MONTH AS DATE_END
  FROM RujelStatic.PL_HOLIDAY_TYPE
  WHERE NOT EXISTS (select * from PL_HOLIDAY);

CREATE TABLE IF NOT EXISTS SCHEMA_VERSION (
  MODEL_NAME varchar(255),
  VERSION_NUMBER smallint unsigned NOT NULL,
  VERSION_TITLE varchar(255),
  INSTALL_DATE timestamp
);

INSERT INTO SCHEMA_VERSION (MODEL_NAME,VERSION_NUMBER,VERSION_TITLE)
  VALUES ('EduPlanYearly',1,'0.9');

-- v2 (0.9.4) --

ALTER TABLE PL_HOURS ADD INDEX (CYCLE_ID);

INSERT INTO SCHEMA_VERSION (MODEL_NAME,VERSION_NUMBER,VERSION_TITLE)
  VALUES ('EduPlanYearly',2,'0.9.4');

-- v3 (0.9.5) --

ALTER TABLE PL_EDU_PERIOD
  ADD COLUMN `ITOG_ID` smallint;

INSERT INTO SCHEMA_VERSION (MODEL_NAME,VERSION_NUMBER,VERSION_TITLE)
  VALUES ('EduPlanYearly',3,'0.9.5');
